# Macros for PVM3
# Tomaz Solc

dnl AM_PATH_PVM3()
dnl

AC_DEFUN(AM_PATH_PVM3,[
        no_pvm=no

        AC_MSG_CHECKING(for PVM_ROOT)
        if test "x$PVM_ROOT" = "x" ; then
                AC_MSG_RESULT(no)

                AC_CHECK_LIB(pvm3, pvm_spawn, dummy=1, [no_pvm=yes])
                AC_CHECK_HEADER(pvm3.h, , [no_pvm=yes])

                PVM_LIBS="-lpvm3"
        else
                AC_MSG_RESULT("$PVM_ROOT")

                AC_PATH_PROG(GETARCH, "pvmgetarch", no, "$PVM_ROOT/lib:$PATH")

                AC_MSG_CHECKING("for PVM_ARCH")

                if test "x$PVM_ARCH" = "x" ; then
                        if test "$GETARCH" = "no" ; then
                                AC_MSG_RESULT("no")
                                no_pvm=yes
                        else
                                PVM_ARCH=`$GETARCH`
                                AC_MSG_RESULT("$PVM_ARCH")
                        fi
                else
                        AC_MSG_RESULT("$PVM_ARCH");
                fi

                if test "$no_pvm" = "no" ; then
                        PVM_CFLAGS="-I$PVM_ROOT/include"
                        PVM_LIBS="-L$PVM_ROOT/lib/$PVM_ARCH -lpvm3"

                        ac_save_CFLAGS="$CFLAGS"
                        CFLAGS="$CFLAGS -L$PVM_ROOT/lib/$PVM_ARCH"
                        AC_CHECK_LIB(pvm3, pvm_spawn, dummy=1, no_pvm=yes)
                        CFLAGS="$ac_save_CFLAGS"

                        CPPFLAGS="$CPPFLAGS $PVM_CFLAGS"
                        AC_CHECK_HEADER(pvm3.h, , no_pvm=yes)
                        CPPFLAGS="$ac_save_CPPFLAGS"
                fi
        fi

        if test "$no_pvm" = "yes" ; then
                AC_MSG_WARN("Parallel algorithm disabled")
                PVM_LIBS=""
                PVM_CFLAGS=""
        else
                AC_DEFINE(HAVE_LIBPVM3)
        fi

        AC_SUBST(PVM_LIBS)
        AC_SUBST(PVM_CFLAGS)

])
