/* TABLIX, PGA highschool timetable generator                              */
/* Copyright (C) 2002 Tomaz Solc                                           */

/* This program is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by    */
/* the Free Software Foundation; either version 2 of the License, or       */
/* (at your option) any later version.                                     */

/* This program is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/* GNU General Public License for more details.                            */

/* You should have received a copy of the GNU General Public License       */
/* along with this program; if not, write to the Free Software             */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

/* $Id: main.c,v 1.23 2002/06/28 09:54:49 avian Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>

#ifdef HAVE_LIBPVM3
  #include <pvm3.h>
#else
  #include <signal.h>
#endif

#include "data.h"
#include "main.h"
#include "xmlsup.h"
#include "error.h"

chromo *parentpop;

int *buffer;            /* Time lookup table needed by grade_chromo()   */
int **lead;             /* with pointers */
int **start;

#ifndef HAVE_LIBPVM3
int ctrlc;
#endif

void grade_chromo(chromo *t)
{
        int total, subtotal;
        int d,c,b,a,e;

        int *pnt;

        /* There is an array for each c in TIMES.  */
        /* Begins with start[c], ends with lead[c] */

        for(c=0;c<TIMES;c++) {
                lead[c]=start[c];
        }

        total=0;

        /* We put tuplenums in these arrays and than scan them for */
        /* conflicting tuples                                      */

        for(c=0;c<tuplenum;c++) {
                *lead[t->inf[c].time]=c;
                lead[t->inf[c].time]++;
        }

        for(c=0;c<tuplenum;c++) {
                a=t->inf[c].time;

                for(pnt=start[a];pnt<lead[a];pnt++) if (*pnt<c) {
                        b=*pnt;
                        if (t->inf[c].room==t->inf[b].room) {

                                /* Poglejmo najprej, ce sta dva tupla */
                                /* na istem kraju in casu hkrati */

                                total+=WEIGHT1;
                        } else {

                                /* Ce mora biti ucitelj ali razred */
                                /* hkrati na dve koncih/krajih */

                                if (tuplemap[c]->tid==tuplemap[b]->tid) total+=WEIGHT2;
                                if (cmap[tuplemap[c]->cid]->conflict[tuplemap[b]->cid]) total+=WEIGHT2;

                                /* NEW * We use conflicts here */
                        }
                }

                /* Restrictions */

                if (smap[tuplemap[c]->sid]->roomnum) {
                        if (!smap[tuplemap[c]->sid]->roomok[t->inf[c].room]) total+=WEIGHT6;
                }
        }

        /* Je urnik mogoc? */
        t->possible=total;

        if (total>0) {
                total+=WEIGHT11;
        }

        /* Ocenjujemo tudi primernost za razrede... */
        extend_chromo(t);
        pnt=cextbuff;
        for(c=0;c<cmapnum;c++) {
                subtotal=0;
                for(a=0;a<DAYS;a++) {
                        b=0;
                        while (b<PERIODS) {
                                if (pnt[b+a*PERIODS]!=-1) break;
                                b++;
                        }

                        /* je ta dan sploh kaj zaseden? */
                        if (b<PERIODS) {

                                /* Proste ure zjutraj */
                                total+=b*WEIGHT3;

                                d=b;
                                e=1;
                                b++;

                                /* Luknje. Za vsako nadaljno */
                                /* prosto uro dodaj WEIGHT5 */
                                while (b<PERIODS) {
                                        if (pnt[b+a*PERIODS]==-1) {
                                                subtotal++;
                                        } else {
                                                d=b;
                                                if (tuplemap[pnt[b+a*PERIODS]]->cid==c)
                                                e++;
                                        }

                                        b++;
                                }

                                /* na koncu odstej tiste ure, ki so po */
                                /* zadnji ucni uri */
                                subtotal-=(PERIODS-1)-d;

                                /* za vsako uro odstopanja od povprecnega */
                                /* stevila ur na dan dodaj WEIGHT9 */

                                e-=cmap[c]->perday;

                                total+=e*e*WEIGHT9;
                        } else {
                                total+=cmap[c]->perday*cmap[c]->perday*WEIGHT9;
                        }
                }
                total+=subtotal*WEIGHT5;


                /* sprehodi iz ene ucilnice v drugo */

                subtotal=0;

                b=0;
                while (pnt[b]==-1) b++;
                a=t->inf[pnt[b]].room;
                do {
                        if (a!=t->inf[pnt[b]].room) {
                                subtotal++;
                                a=t->inf[pnt[b]].room;
                        }
                        do b++; while (pnt[b]==-1);
                } while (b<TIMES);

                total+=subtotal*WEIGHT4;
                pnt+=TIMES;
        };

        /* ...in ucitelje */
        textend_chromo(t);
        pnt=textbuff;
        for(c=0;c<tmapnum;c++) {

                subtotal=0;
                for(a=0;a<DAYS;a++) {
                        b=0;
                        while (b<PERIODS) {
                                if (pnt[b+a*PERIODS]!=-1) break;
                                b++;
                        }

                        /* je ta dan sploh kaj zaseden? */
                        if (b<PERIODS) {

                                /* Proste ure zjutraj */
                                total+=b*WEIGHT7;

                                d=b;
                                e=1;
                                b++;

                                /* Luknje. Za vsako nadaljno */
                                /* prosto uro dodaj WEIGHT8 */
                                while (b<PERIODS) {
                                        if (pnt[b+a*PERIODS]==-1) {
                                                subtotal++;
                                        } else {
                                                d=b;
                                                e++;
                                        }

                                        b++;
                                }

                                /* na koncu odstej tiste ure, ki so po */
                                /* zadnji ucni uri */
                                subtotal-=(PERIODS-1)-d;

                                /* za vsako uro odstopanja od povprecnega */
                                /* stevila ur na dan dodaj WEIGHT10 */

                                e-=tmap[c]->perday;

                                total+=e*e*WEIGHT10;
                        } else {
                                total+=tmap[c]->perday*tmap[c]->perday*WEIGHT10;
                        }

                }
                total+=subtotal*WEIGHT8;

                /* pri uciteljih ne upostevamo sprehodov iz ucilnice v */
                /* ucilnico. */
                pnt+=TIMES;
        };

        t->grade=total;
}

void mate_chromo(chromo *t1, chromo *t2, chromo *b1, chromo *b2)
{
        int a,b,c;
        int temp;

        a=rand()%tuplemut;
        b=rand()%tuplemut;

        for(c=0;c<tuplemut;c++) {
                if (c<a) {
                        temp=t1->inf[c].time;
                        b1->inf[c].time=t2->inf[c].time;
                        b2->inf[c].time=temp;
                } else {
                        b2->inf[c].time=t2->inf[c].time;
                        b1->inf[c].time=t1->inf[c].time;
                }
                if (c<b) {
                        temp=t1->inf[c].room;
                        b1->inf[c].room=t2->inf[c].room;
                        b2->inf[c].room=temp;
                } else {
                        b2->inf[c].room=t2->inf[c].room;
                        b1->inf[c].room=t1->inf[c].room;
                }
        }

        b1->grade=-1;
        b2->grade=-1;
}

void mutate_chromo(chromo *t1)
{
        int a,b;
        int temp;

        a=rand()%tuplemut;
        b=rand()%tuplemut;

        temp=t1->inf[a].time;
        t1->inf[a].time=t1->inf[b].time;
        t1->inf[b].time=temp;

        a=rand()%tuplemut;
        b=rand()%tuplemut;

        temp=t1->inf[a].room;
        t1->inf[a].room=t1->inf[b].room;
        t1->inf[b].room=temp;
        t1->grade=-1;
}

void rand_chromo(chromo *t1)
{
        int a,b;

        a=rand()%tuplemut;
        b=rand()%tuplemut;

        t1->inf[a].time=rand()%TIMES;
        t1->inf[b].room=rand()%rmapnum;
        t1->grade=-1;
}
/*
void print_chromo(chromo *t, int cid)
{
        int echromo[TIMES];
        int c,b,a;

        extend_chromo(t, echromo, cid);

        for(c=-2;c<PERIODS;c++) {
                a=c;
                if (c==-2) printf("Mon\tTue\tWed\tThu\tFri"); else
                if (c==-1) printf("-----\t-----\t-----\t-----\t-----"); else
                for(b=0;b<DAYS;b++) {
                        if (echromo[a]!=-1) {
                                printf("%d P%d\t", tuplemap[echromo[a]]->tid, t->inf[echromo[a]].room);
                        } else {
                                printf("\t");
                        }

                        a+=PERIODS;
                }
                printf("\n");
        }
}
*/
int compare_chromo(const void *t1, const void *t2)
{
        return(((chromo *)t1)->grade-((chromo *)t2)->grade);
}

#ifndef HAVE_LIBPVM3
void sighandler(int num)
{
        if (ctrlc<1) {
                ctrlc++;
        } else {
                exit(1);
        }
}
#endif

int main(int argc, char *argv[])
{
        int a,b,c,d,u;
        int flag;
        int temp;
        int g1, g2;

        int tour[TOURSIZE];

        struct timeval t;

        char xmlsrc[256];

        int restore;

        FILE *tmpfile;

        #ifdef HAVE_LIBPVM3
          int parent, sibling;
          char *tmpbuff;
        #else
          char prefix[256];
          FILE *saved;
          #ifdef HAVE_CONV
            FILE *debug;
            char dname[256];
          #endif
        #endif

        restore=-1;

        /* *** Get new random seed                      *** */
        gettimeofday(&t, NULL);
        srand(t.tv_usec);               /* <-- should this be fixed? */

        /* *** Parse command line options               *** */
        #ifdef HAVE_LIBPVM3
        #else
        strcpy(prefix, "./");

        while ((c=getopt(argc, argv, "o:r"))!=-1) {
                switch (c) {
                        case 'o': strncpy(prefix, optarg, 256);
                                  break;
                        case 'r': restore=1;
                }
        }
        if (!(optind<argc)) fatal("Wrong arguments");
        #endif

        /* *** Get XML input (via pvm3 or local file)   *** */
        #ifdef HAVE_LIBPVM3
        parent=pvm_parent();

        tmpnam(xmlsrc);
        tmpfile=fopen(xmlsrc, "w");
        if (tmpfile==NULL) fatal("Can't open temporary file");

        tmpbuff=malloc(LINEBUFFSIZE);

        do {
                pvm_recv(parent, MSG_XMLDATA);

                pvm_upkint(&c, 1, 1);
                pvm_upkstr(tmpbuff);

                fprintf(tmpfile, "%s", tmpbuff);
        } while (c);

        free(tmpbuff);
        fclose(tmpfile);
        #else
        strncpy(xmlsrc, argv[optind], 256);
        #endif

        xmlsup_main(xmlsrc);

        #ifdef HAVE_LIBPVM3
        unlink(xmlsrc);
        #endif

        /* *** Open file for convergence info           *** */
        #if (!HAVE_LIBPVM3 && HAVE_CONV)
        snprintf(dname, 256, "%sconv.txt", prefix);
        debug=fopen(dname, restore>0?"a":"w");
        #endif

        /* *** First population (restore if necessary)  *** */
        parentpop=malloc(sizeof(*parentpop)*POPSIZE);
        for(c=0;c<POPSIZE;c++) {
                parentpop[c].inf=malloc(sizeof(*parentpop[c].inf)*tuplenum);
        }

        #ifdef HAVE_LIBPVM3
        pvm_recv(parent, MSG_RESTOREPOP);
        pvm_upkint(&restore, 1, 1);
        #else
        if (restore>0) {
                snprintf(xmlsrc, 256, "%ssave.txt", prefix);
                saved=fopen(xmlsrc, "r");
                if (saved==NULL) {
                        perror("tablix");
                        exit(1);
                }
                fscanf(saved, "%d", &restore);
        }
        #endif

        if (restore>0&&restore!=tuplenum) fatal("XML input and saved population mismatch");

        if (restore<=0) {
                u=1;
                for(c=0;c<POPSIZE;c++) {
                        for(b=0;b<tuplemut;b++) {
                                parentpop[c].inf[b].time=rand()%TIMES;
                                parentpop[c].inf[b].room=rand()%rmapnum;
                        }
                        for(b=tuplemut;b<tuplenum;b++) {
                                parentpop[c].inf[b].time=tuplemap[b]->imut_time;
                                parentpop[c].inf[b].room=tuplemap[b]->imut_room;
                        }
                        parentpop[c].grade=-1;
                }
        } else
        #ifdef HAVE_LIBPVM3
        {
                pvm_upkint(&u, 1, 1);
                for(c=0;c<POPSIZE;c++) {
                        pvm_upkint((int *) parentpop[c].inf, tuplenum*2, 1);
                        parentpop[c].grade=-1;
                }
        }
        #else
        {
                fscanf(saved, "%d", &u);
                for(c=0;c<POPSIZE;c++) {
                        for(b=0;b<tuplenum;b++) {
                                fscanf(saved, "%d %d", &parentpop[c].inf[b].time, &parentpop[c].inf[b].room);
                        }
                        fscanf(saved, "%s", xmlsrc);
                        if (strcmp(xmlsrc, "+")) fatal("XML input and saved population mismatch");
                        parentpop[c].grade=-1;
                }

                fclose(saved);
        }
        #endif

        /* *** Get initial sibling tid (pvm3 only)      *** */
        #ifdef HAVE_LIBPVM3
        pvm_recv(parent, MSG_SIBLING);
        pvm_upkint(&sibling, 1, 1);
        pvm_notify(PvmTaskExit, MSG_MASTERKILL, 1, &parent);
        #endif

        sprintf(xmlsrc, "I have %s%d tuples (%d immutable)", restore>0?"restored ":"", tuplenum, tuplenum-tuplemut);
        notify(xmlsrc);

        /* *** Install signal handler (non-pvm3 only)   *** */
        #ifndef HAVE_LIBPVM3
        ctrlc=0;
        signal(SIGINT, sighandler);
        #endif

        /* *** Various buffers for grading algorithm    *** */
        buffer=malloc(tuplenum*TIMES*sizeof(*buffer));
        lead=malloc(TIMES*sizeof(*lead));
        start=malloc(TIMES*sizeof(*start));

        for(c=0;c<TIMES;c++) {
                start[c]=buffer+c*tuplenum;
                lead[c]=start[c];
        }

        data_init();

        g1=GRADEMAX;
        g2=0;

        /* ***                                          *** */
        /* *** MAIN LOOP (Magic starts here)            *** */
        /* ***                                          *** */

        while (1) {

        for(c=0;c<POPSIZE;c++)
        if (parentpop[c].grade==-1) grade_chromo(&parentpop[c]);

        qsort(parentpop, POPSIZE, sizeof(*parentpop), compare_chromo);

        /* Migration and population saving at SIGINT */
        #ifdef HAVE_LIBPVM3
        if (u%MIGRTIME==0) {
                pvm_initsend(0);
                for(c=0;c<POPSIZE/MIGRPART;c++) {
                        pvm_pkint((int *) parentpop[c].inf, tuplenum*2, 1);
                }
                pvm_send(sibling, MSG_MIGRATION);
        }

        if (pvm_nrecv(parent, MSG_SENDPOP)>0) {
                pvm_initsend(0);
                pvm_pkint(&tuplenum, 1, 1);
                pvm_pkint(&u, 1, 1);
                for(c=0;c<POPSIZE;c++) {
                        pvm_pkint((int *) parentpop[c].inf, tuplenum*2, 1);
                }
                pvm_send(parent, MSG_POPDATA);

                pvm_exit();
                xmlsup_exit();
                for(c=0;c<POPSIZE;c++) free(parentpop[c].inf);
                free(parentpop);
                free(buffer); free(lead); free(start);
                data_exit();
                free_tuple();

                exit(0);
        }
        #else
        if (ctrlc==1) {
                snprintf(xmlsrc, 256, "%ssave.txt", prefix);
                saved=fopen(xmlsrc, "w");

                if (saved==NULL) perror("tablix");

                fprintf(saved, "%d\n", tuplenum);
                fprintf(saved, "%d\n", u);

                for(c=0;c<POPSIZE;c++) {
                        for(b=0;b<tuplenum;b++) {
                                fprintf(saved, "%d %d\n", parentpop[c].inf[b].time, parentpop[c].inf[b].room);
                        }
                        fprintf(saved, "+\n");
                }
                fclose(saved);

                xmlsup_exit();
                for(c=0;c<POPSIZE;c++) free(parentpop[c].inf);
                data_exit();
                free(buffer); free(lead); free(start);
                free(parentpop);
                free_tuple();

                exit(0);
        }
        #endif

        a=parentpop[0].grade;
        b=1;
        for(c=1;c<POPSIZE;c++) {
                if (parentpop[c].grade==a) {
                        b++;
                } else {
                        a=parentpop[c].grade;
                        b=1;
                }

                if (b>MAXEQUAL) {
/*
                        for(d=0;d<tuplemut;d++) {
                                parentpop[c].inf[d].time=rand()%TIMES;
                                parentpop[c].inf[d].room=rand()%ROOMS;
                        }
*/
                        parentpop[c].grade=GRADEMAX;
                }
        }

        #ifdef HAVE_LIBPVM3
        pvm_initsend(0);
        pvm_pkint(&parentpop[0].grade, 1, 1);
        pvm_pkint(&u, 1, 1);
        pvm_pkint(&parentpop[0].possible, 1, 1);
        pvm_send(parent, MSG_INFO);
        #else
        printf("-------%d\n", u);
        for(c=0;c<5;c++) {
                printf("%d (%d)\n", parentpop[c].grade, parentpop[c].possible);
        }
        #endif

        if (parentpop[0].grade<g1) {
                g1=parentpop[0].grade;
                g2=0;
        } else g2++;

        #ifdef HAVE_LIBPVM3
        /* in an unlikely event of a disaster... */
        if (pvm_nrecv(-1, MSG_MASTERKILL)>0) {
                xmlsup_exit();
                for(c=0;c<POPSIZE;c++) free(parentpop[c].inf);
                data_exit();
                free(buffer); free(lead); free(start);
                free(parentpop);
                free_tuple();
                pvm_exit();
                exit(1);
        }
        #endif

        if ((g2>FINISH)&&(!parentpop[0].possible)) {
                notify("I have solution");

                #ifdef HAVE_LIBPVM3
                tmpnam(xmlsrc);
                #else
                snprintf(xmlsrc, 256, "%sresult.xml", prefix);
                #endif

                xmlsup_addchromo(parentpop);

                tmpfile=fopen(xmlsrc, "w");
                xmlsup_dump(tmpfile);
                fclose(tmpfile);
                /*  print_chromo_html(parentpop, xmlsrc); */

                #ifdef HAVE_LIBPVM3
                tmpfile=fopen(xmlsrc, "r");
                if (tmpfile==NULL) fatal("Can't open temporary file");

                tmpbuff=malloc(LINEBUFFSIZE);

                while (fgets(tmpbuff, LINEBUFFSIZE, tmpfile)!=NULL) {
                        c=1;
                        pvm_initsend(0);
                        pvm_pkint(&c, 1, 1);
                        pvm_pkstr(tmpbuff);
                        pvm_send(parent, MSG_RESULTDATA);
                }

                pvm_initsend(0);
                c=0;
                strcpy(tmpbuff, "<!-- End of file -->\n");
                pvm_pkint(&c, 1, 1);
                pvm_pkstr(tmpbuff);
                pvm_send(parent, MSG_RESULTDATA);

                free(tmpbuff);
                fclose(tmpfile);
                unlink(xmlsrc);

                pvm_exit();
                #else
                #ifdef HAVE_CONV
                fclose(debug);
                #endif
                #endif

                xmlsup_exit();
                for(c=0;c<POPSIZE;c++) free(parentpop[c].inf);
                data_exit();
                free(buffer); free(lead); free(start);
                free(parentpop);
                free_tuple();

                exit(0);
        }

        #if (!HAVE_LIBPVM3 && HAVE_CONV)
        fprintf(debug, "%d\t%d\t%d\n", u, parentpop[0].grade, parentpop[0].possible);
        fflush(debug);
        #endif

        for(c=POPSIZE/2;c<POPSIZE;c+=2) {
                a=rand()%(POPSIZE/2);
                b=rand()%(POPSIZE/2);

                if (parentpop[a].grade>parentpop[b].grade) {
                        d=a;
                        a=b;
                        b=d;
                }

                for(d=2;d<TOURSIZE;d++) {
                        temp=rand()%(POPSIZE/2);

                        if (parentpop[temp].grade<parentpop[a].grade) a=temp; else
                        if (parentpop[temp].grade<parentpop[b].grade) b=temp;
                }

                mate_chromo(&parentpop[a], &parentpop[b], &parentpop[c], &parentpop[c+1]);
        }

        for(c=0;c<(POPSIZE/2/MUTATEPART);c++) {
                a=rand()%(POPSIZE/2);
                mutate_chromo(&parentpop[a]);
        }

        for(c=0;c<(POPSIZE/2/RANDPART);c++) {
                a=rand()%(POPSIZE/2);
                rand_chromo(&parentpop[a]);
        }

        #ifdef HAVE_LIBPVM3
        if (pvm_nrecv(-1, MSG_MIGRATION)>0) {
                for(c=0;c<POPSIZE/MIGRPART;c++) {
                        pvm_upkint((int *) parentpop[POPSIZE-c-1].inf, tuplenum*2, 1);
                }
        }

        if (pvm_nrecv(parent, MSG_SIBLING)>0) {
                pvm_upkint(&sibling, 1, 1);
                notify("I have new sibling information");
        }
        #endif

        u++;
        }

        /* Should be never reached */

        return(0);
}
